package com.gic.enterprise.service.outer;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.bizdict.api.dto.BizdictDTO;
import com.gic.bizdict.sdk.service.impl.RedisCacheBizdictService;
import com.gic.enterprise.dto.EnterpriseSmsPackageDTO;
import com.gic.enterprise.dto.PackageDTO;
import com.gic.enterprise.dto.SmsPackageDTO;
import com.gic.enterprise.service.PackApiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service("packApiService")
public class PackageApiServiceImpl implements PackApiService {
    @Autowired
    private RedisCacheBizdictService bizdictService;

    @Override
    public ServiceResponse<List<PackageDTO>> listAllPackage() {
        List<BizdictDTO> list = this.bizdictService.treeByCategoryCode("package_service_type");
        List<PackageDTO> result = new ArrayList<>();
        for(BizdictDTO dto : list){
            PackageDTO packageDTO = new PackageDTO();
            packageDTO.setPackageName(dto.getName());
            packageDTO.setIcon(dto.getAliasName());
            packageDTO.setDesc(dto.getValueContent());
            packageDTO.setType(Integer.valueOf(dto.getCode()));
            result.add(packageDTO);
        }
        return ServiceResponse.success(result);
    }

    @Override
    public ServiceResponse<List<SmsPackageDTO>> listAllSmsPackage() {
        List<BizdictDTO> list = this.bizdictService.treeByCategoryCode("sms_package");
        List<SmsPackageDTO> result = new ArrayList<>();
        for(BizdictDTO dto : list){
            SmsPackageDTO smsPackageDTO = new SmsPackageDTO();
            smsPackageDTO.setSmsPackageName(dto.getCategoryName());
            smsPackageDTO.setSmsPackageCode(dto.getCode());
            smsPackageDTO.setItemCount(Integer.valueOf(dto.getName()));
            smsPackageDTO.setItemFee(Double.valueOf(dto.getValueContent()));
            result.add(smsPackageDTO);
        }
        return ServiceResponse.success(result);
    }

    @Override
    public ServiceResponse<List<EnterpriseSmsPackageDTO>> listEnterpriseSmsPackage(Integer enterpriseId) {
        return null;
    }
}
