package com.gic.enterprise.web.controller;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.gic.api.base.commons.Page;
import com.gic.enterprise.web.vo.billing.InvoiceListVO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.constant.PayTypeEnum;
import com.gic.enterprise.dto.InvoiceDTO;
import com.gic.enterprise.qo.BillListQueryQO;
import com.gic.enterprise.qo.InvoiceListQueryQO;
import com.gic.enterprise.service.BillingPayInfoApiService;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.web.vo.BillListVO;
import com.gic.enterprise.constant.billing.InvoiceStatusEnum;
import com.gic.finance.service.InvoiceManageApiService;

@RestController
@RequestMapping("/billing-pay-info")
public class BillingPayInfoController {
    private static final Logger LOGGER = LoggerFactory.getLogger(BillingPayInfoController.class);

    @Autowired
    private BillingPayInfoApiService billingPayInfoApiService;
    @Autowired
    private InvoiceManageApiService invoiceManageApiService;

    /**
     * 为开票单据列表
     * @Title: listBill 
     * @Description:
      * @author guojuxing
     * @param params 
     * @return  com.gic.commons.webapi.reponse.RestResponse 
      */
    @RequestMapping("/list-bill")
    public RestResponse listBill(BillListQueryQO params) {
        params.setEnterpriseId(1111);
        return ResultControllerUtils.commonPageResult(billingPayInfoApiService.listBill(params), BillListVO.class);
    }

    @RequestMapping("/list-pay-type")
    public RestResponse listPayType() {
        Map<Integer, String> resultMap = new HashMap<>(16);
        for (PayTypeEnum payTypeEnum : PayTypeEnum.values()) {
            resultMap.put(payTypeEnum.getCode(), payTypeEnum.getMessage());
        }
        return RestResponse.success(resultMap);
    }

    @RequestMapping("/list-invoice-status")
    public RestResponse listInvoiceStatus() {
        Map<Integer, String> resultMap = new HashMap<>(16);
        for (InvoiceStatusEnum invoiceStatusEnum : InvoiceStatusEnum.values()) {
            resultMap.put(invoiceStatusEnum.getCode(), invoiceStatusEnum.getMessage());
        }
        return RestResponse.success(resultMap);
    }

    /**
     * 开票
     * @Title: applyInvoice 
     * @Description:
      * @author guojuxing
     * @param invoiceDTO
     * @param billingAmount
     * @param invoiceType 
     * @return  com.gic.commons.webapi.reponse.RestResponse 
      */
    @RequestMapping("/apply-invoice")
    public RestResponse applyInvoice(InvoiceDTO invoiceDTO, Double billingAmount, Integer invoiceType, String serialNumber) {
        //todo 调用发起开票申请
        //todo 更改支付信息中的发票状态未已开具
        return RestResponse.success();
    }

    @RequestMapping("/cancel-invoice")
    public RestResponse cancelInvoice(Integer invoiceManageId) {
        //todo 调用开票取消
        return RestResponse.success();
    }

    /**
     * 已申请开票单据列表
     * @Title: listInvoice 
     * @Description:
      * @author guojuxing
     * @param params 
     * @return  com.gic.commons.webapi.reponse.RestResponse 
      */
    @RequestMapping("/list-invoice")
    public RestResponse listInvoice(InvoiceListQueryQO params) {
        //todo 发票列表
        Page page = new Page();
        List<InvoiceListVO> voList = new ArrayList<>(2);
        voList.add(new InvoiceListVO());
        page.setResult(voList);
        return RestResponse.success(page);
    }

}
