package com.gic.enterprise.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.dto.PackageDTO;
import com.gic.enterprise.dto.SmsPackageDTO;
import com.gic.enterprise.response.EnterpriseRestResponse;
import com.gic.enterprise.service.PackageApiService;
import com.gic.enterprise.web.vo.PackageVO;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
public class PackageController {
    private Logger logger = LogManager.getLogger(PackageController.class);
    @Autowired
    private PackageApiService  packApiService;

    @RequestMapping("list-all-package")
    public RestResponse listAllPackage(){
        ServiceResponse<List<PackageDTO>> serviceResponse = this.packApiService.listAllPackage();
        if(serviceResponse.isSuccess()){
            return RestResponse.success(EntityUtil.changeEntityByJSON(PackageVO.class, serviceResponse.getResult()));
        }
        return EnterpriseRestResponse.failure(serviceResponse);
    }

    @RequestMapping("list-all-sms-package")
    public RestResponse listAllSmspackage(){
        ServiceResponse<List<SmsPackageDTO>> response = this.packApiService.listAllSmsPackage();
        if(response.isSuccess()){
            return RestResponse.success(response.getResult());
        }else {
            return EnterpriseRestResponse.failure(response);
        }
    }
}
